/**
 * @file mathlib_extra.c
 * @brief Special, additional math algorithms for floating-point values
 */

/*
Copyright (C) 2002-2011 UFO: Alien Invasion.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "mathlib_extra.h"

/**
 * @brief <What is function does (briefly)>
 * @param[in] x <what is x>
 * @param[in] y <what is y>
 * @param[in] z <what is z>
 * @return <what, if not obvious>
 * @note better parameter names are welcome
 */
double FpCurve1D_u_in (double x, double y, double z)
{
	if (x > z) {
		double x_mod = (x - z) / (1.f - z);

		x_mod = FpCurveDn(x_mod, y);
		x_mod *= 1.f - z;
		x_mod += z;
		return x_mod;
	}
	if (x < z) {
		double x_mod = (z - x) / z;

		x_mod = FpCurveDn(x_mod, y);
		x_mod *= z;
		x_mod = z - x_mod;
		return x_mod;
	}
	/* x = z, so no change */
	return x;
}

/**
 * @brief <What is function does (briefly)>
 * @param[in] x <what is x>
 * @param[in] y <what is y>
 * @param[in] z <what is z>
 * @return <what, if not obvious>
 */
double FpCurve1D_u_out (double x, double y, double z)
{
	if (x > z) {
		double x_mod = (x - z) / (1.f - z);

		x_mod = FpCurveUp(x_mod, y);
		x_mod *= 1.f - z;
		x_mod += z;
		return x_mod;
	}
	if (x < z) {
		double x_mod = (z - x) / z;

		x_mod = FpCurveUp(x_mod, y);
		x_mod *= z;
		x_mod = z - x_mod;
		return x_mod;
	}
	/* x = z, so no change */
	return x;
}
